Index: drivers/filesystems/btrfs/balance.c
===================================================================
--- drivers/filesystems/btrfs/balance.c	(révision 75772)
+++ drivers/filesystems/btrfs/balance.c	(copie de travail)
@@ -1646,116 +1785,258 @@
                             break;
                         }
                     }
-                    
+
                     ExReleaseResourceLite(&c2->lock);
                 }
 
                 le2 = le2->Flink;
             }
-            
+
             // allocate new chunk if necessary
             if (!done) {
-                newchunk = alloc_chunk(Vcb, Vcb->data_flags);
-                
-                if (!newchunk) {
-                    ERR("could not allocate new chunk\n");
+                Status = alloc_chunk(Vcb, Vcb->data_flags, &newchunk, FALSE);
+
+                if (!NT_SUCCESS(Status)) {
+                    ERR("alloc_chunk returned %08x\n", Status);
                     ExReleaseResourceLite(&Vcb->chunk_lock);
-                    Status = STATUS_DISK_FULL;
                     goto end;
                 }
-                
+
                 ExAcquireResourceExclusiveLite(&newchunk->lock, TRUE);
-                
+
+                newchunk->balance_num = Vcb->balance.balance_num;
+
                 if (!find_data_address_in_chunk(Vcb, newchunk, dr->size, &dr->new_address)) {
                     ExReleaseResourceLite(&newchunk->lock);
+                    ExReleaseResourceLite(&Vcb->chunk_lock);
                     ERR("could not find address in new chunk\n");
                     Status = STATUS_DISK_FULL;
                     goto end;
                 } else {
-                    increase_chunk_usage(newchunk, dr->size);
-                    space_list_subtract(Vcb, newchunk, FALSE, dr->new_address, dr->size, &rollback);
+                    newchunk->used += dr->size;
+                    space_list_subtract(newchunk, FALSE, dr->new_address, dr->size, &rollback);
                 }
-                
+
                 ExReleaseResourceLite(&newchunk->lock);
             }
-            
+
             ExReleaseResourceLite(&Vcb->chunk_lock);
         }
-        
+
         dr->newchunk = newchunk;
-        
-        csum = ExAllocatePoolWithTag(PagedPool, dr->size * sizeof(UINT32) / Vcb->superblock.sector_size, ALLOC_TAG);
+
+        bmparr = ExAllocatePoolWithTag(PagedPool, (ULONG)sector_align((dr->size / Vcb->superblock.sector_size) + 1, sizeof(ULONG)), ALLOC_TAG);
+        if (!bmparr) {
+            ERR("out of memory\n");
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            goto end;
+        }
+
+        csum = ExAllocatePoolWithTag(PagedPool, (ULONG)(dr->size * sizeof(UINT32) / Vcb->superblock.sector_size), ALLOC_TAG);
         if (!csum) {
             ERR("out of memory\n");
+            ExFreePool(bmparr);
             Status = STATUS_INSUFFICIENT_RESOURCES;
             goto end;
         }
-        
-        Status = load_csum(Vcb, csum, dr->address, dr->size / Vcb->superblock.sector_size, NULL);
 
-        if (NT_SUCCESS(Status)) {
-            add_checksum_entry(Vcb, dr->new_address, dr->size / Vcb->superblock.sector_size, csum, NULL, &rollback);
-            add_checksum_entry(Vcb, dr->address, dr->size / Vcb->superblock.sector_size, NULL, NULL, &rollback);
+        RtlInitializeBitMap(&bmp, bmparr, (ULONG)(dr->size / Vcb->superblock.sector_size));
+        RtlSetAllBits(&bmp); // 1 = no csum, 0 = csum
+
+        searchkey.obj_id = EXTENT_CSUM_ID;
+        searchkey.obj_type = TYPE_EXTENT_CSUM;
+        searchkey.offset = dr->address;
+
+        Status = find_item(Vcb, Vcb->checksum_root, &tp, &searchkey, FALSE, NULL);
+        if (!NT_SUCCESS(Status) && Status != STATUS_NOT_FOUND) {
+            ERR("find_item returned %08x\n", Status);
+            ExFreePool(csum);
+            ExFreePool(bmparr);
+            goto end;
         }
 
-        ExFreePool(csum);
-        
-        off = 0;
-        
-        while (off < dr->size) {
-            ULONG ds = min(dr->size - off, 0x100000);
-            
-            Status = read_data(Vcb, dr->address + off, ds, NULL, FALSE, data, c, NULL, NULL, FALSE);
-            if (!NT_SUCCESS(Status)) {
-                ERR("read_data returned %08x\n", Status);
-                goto end;
+        if (Status != STATUS_NOT_FOUND) {
+            do {
+                traverse_ptr next_tp;
+
+                if (tp.item->key.obj_type == TYPE_EXTENT_CSUM) {
+                    if (tp.item->key.offset >= dr->address + dr->size)
+                        break;
+                    else if (tp.item->size >= sizeof(UINT32) && tp.item->key.offset + (tp.item->size * Vcb->superblock.sector_size / sizeof(UINT32)) >= dr->address) {
+                        UINT64 cs = max(dr->address, tp.item->key.offset);
+                        UINT64 ce = min(dr->address + dr->size, tp.item->key.offset + (tp.item->size * Vcb->superblock.sector_size / sizeof(UINT32)));
+
+                        RtlCopyMemory(csum + ((cs - dr->address) / Vcb->superblock.sector_size),
+                                      tp.item->data + ((cs - tp.item->key.offset) * sizeof(UINT32) / Vcb->superblock.sector_size),
+                                      (ULONG)((ce - cs) * sizeof(UINT32) / Vcb->superblock.sector_size));
+
+                        RtlClearBits(&bmp, (ULONG)((cs - dr->address) / Vcb->superblock.sector_size), (ULONG)((ce - cs) / Vcb->superblock.sector_size));
+
+                        if (ce == dr->address + dr->size)
+                            break;
+                    }
+                }
+
+                if (find_next_item(Vcb, &tp, &next_tp, FALSE, NULL))
+                    tp = next_tp;
+                else
+                    break;
+            } while (TRUE);
+        }
+
+        lastoff = 0;
+        runlength = RtlFindFirstRunClear(&bmp, &index);
+
+        while (runlength != 0) {
+            if (index > lastoff) {
+                ULONG off = lastoff;
+                ULONG size = index - lastoff;
+
+                // handle no csum run
+                do {
+                    ULONG rl;
+
+                    if (size * Vcb->superblock.sector_size > BALANCE_UNIT)
+                        rl = BALANCE_UNIT / Vcb->superblock.sector_size;
+                    else
+                        rl = size;
+
+                    Status = read_data(Vcb, dr->address + (off * Vcb->superblock.sector_size), rl * Vcb->superblock.sector_size, NULL, FALSE, data,
+                                       c, NULL, NULL, 0, FALSE, NormalPagePriority);
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("read_data returned %08x\n", Status);
+                        ExFreePool(csum);
+                        ExFreePool(bmparr);
+                        goto end;
+                    }
+
+                    Status = write_data_complete(Vcb, dr->new_address + (off * Vcb->superblock.sector_size), data, rl * Vcb->superblock.sector_size,
+                                                 NULL, newchunk, FALSE, 0, NormalPagePriority);
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("write_data_complete returned %08x\n", Status);
+                        ExFreePool(csum);
+                        ExFreePool(bmparr);
+                        goto end;
+                    }
+
+                    size -= rl;
+                    off += rl;
+                } while (size > 0);
             }
-            
-            Status = write_data_complete(Vcb, dr->new_address + off, data, ds, NULL, newchunk);
-            if (!NT_SUCCESS(Status)) {
-                ERR("write_data_complete returned %08x\n", Status);
-                goto end;
-            }
-            
-            off += ds;
+
+            add_checksum_entry(Vcb, dr->new_address + (index * Vcb->superblock.sector_size), runlength, &csum[index], NULL);
+            add_checksum_entry(Vcb, dr->address + (index * Vcb->superblock.sector_size), runlength, NULL, NULL);
+
+            // handle csum run
+            do {
+                ULONG rl;
+
+                if (runlength * Vcb->superblock.sector_size > BALANCE_UNIT)
+                    rl = BALANCE_UNIT / Vcb->superblock.sector_size;
+                else
+                    rl = runlength;
+
+                Status = read_data(Vcb, dr->address + (index * Vcb->superblock.sector_size), rl * Vcb->superblock.sector_size, &csum[index], FALSE, data,
+                                   c, NULL, NULL, 0, FALSE, NormalPagePriority);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("read_data returned %08x\n", Status);
+                    ExFreePool(csum);
+                    ExFreePool(bmparr);
+                    goto end;
+                }
+
+                Status = write_data_complete(Vcb, dr->new_address + (index * Vcb->superblock.sector_size), data, rl * Vcb->superblock.sector_size,
+                                             NULL, newchunk, FALSE, 0, NormalPagePriority);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("write_data_complete returned %08x\n", Status);
+                    ExFreePool(csum);
+                    ExFreePool(bmparr);
+                    goto end;
+                }
+
+                runlength -= rl;
+                index += rl;
+            } while (runlength > 0);
+
+            lastoff = index;
+            runlength = RtlFindNextForwardRunClear(&bmp, index, &index);
         }
 
+        ExFreePool(csum);
+        ExFreePool(bmparr);
+
+        // handle final nocsum run
+        if (lastoff < dr->size / Vcb->superblock.sector_size) {
+            ULONG off = lastoff;
+            ULONG size = (ULONG)((dr->size / Vcb->superblock.sector_size) - lastoff);
+
+            do {
+                ULONG rl;
+
+                if (size * Vcb->superblock.sector_size > BALANCE_UNIT)
+                    rl = BALANCE_UNIT / Vcb->superblock.sector_size;
+                else
+                    rl = size;
+
+                Status = read_data(Vcb, dr->address + (off * Vcb->superblock.sector_size), rl * Vcb->superblock.sector_size, NULL, FALSE, data,
+                                   c, NULL, NULL, 0, FALSE, NormalPagePriority);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("read_data returned %08x\n", Status);
+                    ExFreePool(csum);
+                    ExFreePool(bmparr);
+                    goto end;
+                }
+
+                Status = write_data_complete(Vcb, dr->new_address + (off * Vcb->superblock.sector_size), data, rl * Vcb->superblock.sector_size,
+                                             NULL, newchunk, FALSE, 0, NormalPagePriority);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("write_data_complete returned %08x\n", Status);
+                    ExFreePool(csum);
+                    ExFreePool(bmparr);
+                    goto end;
+                }
+
+                size -= rl;
+                off += rl;
+            } while (size > 0);
+        }
+
         le = le->Flink;
     }
-    
+
     ExFreePool(data);
     data = NULL;
-    
+
     Status = write_metadata_items(Vcb, &metadata_items, &items, NULL, &rollback);
     if (!NT_SUCCESS(Status)) {
         ERR("write_metadata_items returned %08x\n", Status);
         goto end;
     }
-    
+
     le = items.Flink;
     while (le != &items) {
         data_reloc* dr = CONTAINING_RECORD(le, data_reloc, list_entry);
-        
-        Status = add_data_reloc_extent_item(Vcb, dr, &rollback);
+
+        Status = add_data_reloc_extent_item(Vcb, dr);
         if (!NT_SUCCESS(Status)) {
             ERR("add_data_reloc_extent_item returned %08x\n", Status);
             goto end;
         }
-        
+
         le = le->Flink;
     }
-    
+
     le = c->changed_extents.Flink;
     while (le != &c->changed_extents) {
         LIST_ENTRY *le2, *le3;
         changed_extent* ce = CONTAINING_RECORD(le, changed_extent, list_entry);
-        
+
         le3 = le->Flink;
-        
+
         le2 = items.Flink;
         while (le2 != &items) {
             data_reloc* dr = CONTAINING_RECORD(le2, data_reloc, list_entry);
-            
+
             if (ce->address == dr->address) {
                 ce->address = dr->new_address;
                 RemoveEntryList(&ce->list_entry);
@@ -1762,98 +2043,149 @@
                 InsertTailList(&dr->newchunk->changed_extents, &ce->list_entry);
                 break;
             }
-            
+
             le2 = le2->Flink;
         }
-        
+
         le = le3;
     }
-    
-    // update open FCBs
-    // FIXME - speed this up
-    
-    ExAcquireResourceSharedLite(&Vcb->fcb_lock, TRUE);
-    
-    le = Vcb->all_fcbs.Flink;
-    while (le != &Vcb->all_fcbs) {
-        struct _fcb* fcb = CONTAINING_RECORD(le, struct _fcb, list_entry_all);
-        LIST_ENTRY* le2;
 
-        ExAcquireResourceExclusiveLite(fcb->Header.Resource, TRUE);
-        
-        le2 = fcb->extents.Flink;
-        while (le2 != &fcb->extents) {
-            extent* ext = CONTAINING_RECORD(le2, extent, list_entry);
-            
-            if (!ext->ignore) {
-                if (ext->data->type == EXTENT_TYPE_REGULAR || ext->data->type == EXTENT_TYPE_PREALLOC) {
-                    EXTENT_DATA2* ed2 = (EXTENT_DATA2*)ext->data->data;
-                    
-                    if (ed2->size > 0 && ed2->address >= c->offset && ed2->address < c->offset + c->chunk_item->size) {
-                        LIST_ENTRY* le3 = items.Flink;
-                        while (le3 != &items) {
-                            data_reloc* dr = CONTAINING_RECORD(le3, data_reloc, list_entry);
-                            
-                            if (ed2->address == dr->address) {
-                                ed2->address = dr->new_address;
-                                break;
+    Status = STATUS_SUCCESS;
+
+    Vcb->need_write = TRUE;
+
+end:
+    if (NT_SUCCESS(Status)) {
+        // update extents in cache inodes before we flush
+        le = Vcb->chunks.Flink;
+        while (le != &Vcb->chunks) {
+            chunk* c2 = CONTAINING_RECORD(le, chunk, list_entry);
+
+            if (c2->cache) {
+                LIST_ENTRY* le2;
+
+                ExAcquireResourceExclusiveLite(c2->cache->Header.Resource, TRUE);
+
+                le2 = c2->cache->extents.Flink;
+                while (le2 != &c2->cache->extents) {
+                    extent* ext = CONTAINING_RECORD(le2, extent, list_entry);
+
+                    if (!ext->ignore) {
+                        if (ext->extent_data.type == EXTENT_TYPE_REGULAR || ext->extent_data.type == EXTENT_TYPE_PREALLOC) {
+                            EXTENT_DATA2* ed2 = (EXTENT_DATA2*)ext->extent_data.data;
+
+                            if (ed2->size > 0 && ed2->address >= c->offset && ed2->address < c->offset + c->chunk_item->size) {
+                                LIST_ENTRY* le3 = items.Flink;
+                                while (le3 != &items) {
+                                    data_reloc* dr = CONTAINING_RECORD(le3, data_reloc, list_entry);
+
+                                    if (ed2->address == dr->address) {
+                                        ed2->address = dr->new_address;
+                                        break;
+                                    }
+
+                                    le3 = le3->Flink;
+                                }
                             }
-                            
-                            le3 = le3->Flink;
                         }
                     }
+
+                    le2 = le2->Flink;
                 }
+
+                ExReleaseResourceLite(c2->cache->Header.Resource);
             }
-            
-            le2 = le2->Flink;
+
+            le = le->Flink;
         }
-        
-        ExReleaseResourceLite(fcb->Header.Resource);
-        
-        le = le->Flink;
+
+        Status = do_write(Vcb, NULL);
+        if (!NT_SUCCESS(Status))
+            ERR("do_write returned %08x\n", Status);
     }
-    
-    ExReleaseResourceLite(&Vcb->fcb_lock);
-    
-    Status = STATUS_SUCCESS;
-    
-    Vcb->need_write = TRUE;
-    
-end:
-    if (NT_SUCCESS(Status))
-        clear_rollback(Vcb, &rollback);
-    else
+
+    if (NT_SUCCESS(Status)) {
+        clear_rollback(&rollback);
+
+        // update open FCBs
+        // FIXME - speed this up(?)
+
+        ExAcquireResourceSharedLite(&Vcb->fcb_lock, TRUE);
+
+        le = Vcb->all_fcbs.Flink;
+        while (le != &Vcb->all_fcbs) {
+            struct _fcb* fcb = CONTAINING_RECORD(le, struct _fcb, list_entry_all);
+            LIST_ENTRY* le2;
+
+            ExAcquireResourceExclusiveLite(fcb->Header.Resource, TRUE);
+
+            le2 = fcb->extents.Flink;
+            while (le2 != &fcb->extents) {
+                extent* ext = CONTAINING_RECORD(le2, extent, list_entry);
+
+                if (!ext->ignore) {
+                    if (ext->extent_data.type == EXTENT_TYPE_REGULAR || ext->extent_data.type == EXTENT_TYPE_PREALLOC) {
+                        EXTENT_DATA2* ed2 = (EXTENT_DATA2*)ext->extent_data.data;
+
+                        if (ed2->size > 0 && ed2->address >= c->offset && ed2->address < c->offset + c->chunk_item->size) {
+                            LIST_ENTRY* le3 = items.Flink;
+                            while (le3 != &items) {
+                                data_reloc* dr = CONTAINING_RECORD(le3, data_reloc, list_entry);
+
+                                if (ed2->address == dr->address) {
+                                    ed2->address = dr->new_address;
+                                    break;
+                                }
+
+                                le3 = le3->Flink;
+                            }
+                        }
+                    }
+                }
+
+                le2 = le2->Flink;
+            }
+
+            ExReleaseResourceLite(fcb->Header.Resource);
+
+            le = le->Flink;
+        }
+
+        ExReleaseResourceLite(&Vcb->fcb_lock);
+    } else
         do_rollback(Vcb, &rollback);
-    
+
+    free_trees(Vcb);
+
     ExReleaseResourceLite(&Vcb->tree_lock);
-    
+
     if (data)
         ExFreePool(data);
-    
+
     while (!IsListEmpty(&items)) {
         data_reloc* dr = CONTAINING_RECORD(RemoveHeadList(&items), data_reloc, list_entry);
-        
+
         while (!IsListEmpty(&dr->refs)) {
             data_reloc_ref* ref = CONTAINING_RECORD(RemoveHeadList(&dr->refs), data_reloc_ref, list_entry);
-            
+
             ExFreePool(ref);
         }
-        
+
         ExFreePool(dr);
     }
-    
+
     while (!IsListEmpty(&metadata_items)) {
         metadata_reloc* mr = CONTAINING_RECORD(RemoveHeadList(&metadata_items), metadata_reloc, list_entry);
-        
+
         while (!IsListEmpty(&mr->refs)) {
             metadata_reloc_ref* ref = CONTAINING_RECORD(RemoveHeadList(&mr->refs), metadata_reloc_ref, list_entry);
-            
+
             ExFreePool(ref);
         }
-        
+
         ExFreePool(mr);
     }
-    
+
     return Status;
 }
 
@@ -1876,24 +2208,24 @@
 
 static BOOL should_balance_chunk(device_extension* Vcb, UINT8 sort, chunk* c) {
     btrfs_balance_opts* opts;
-    
+
     opts = &Vcb->balance.opts[sort];
-    
+
     if (!(opts->flags & BTRFS_BALANCE_OPTS_ENABLED))
         return FALSE;
-    
+
     if (opts->flags & BTRFS_BALANCE_OPTS_PROFILES) {
         UINT64 type = get_chunk_dup_type(c);
-        
+
         if (!(type & opts->profiles))
             return FALSE;
     }
-    
+
     if (opts->flags & BTRFS_BALANCE_OPTS_DEVID) {
         UINT16 i;
         CHUNK_ITEM_STRIPE* cis = (CHUNK_ITEM_STRIPE*)&c->chunk_item[1];
         BOOL b = FALSE;
-        
+
         for (i = 0; i < c->chunk_item->num_stripes; i++) {
             if (cis[i].dev_id == opts->devid) {
                 b = TRUE;
@@ -1900,17 +2232,17 @@
                 break;
             }
         }
-        
+
         if (!b)
             return FALSE;
     }
-    
+
     if (opts->flags & BTRFS_BALANCE_OPTS_DRANGE) {
         UINT16 i, factor;
         UINT64 physsize;
         CHUNK_ITEM_STRIPE* cis = (CHUNK_ITEM_STRIPE*)&c->chunk_item[1];
         BOOL b = FALSE;
-        
+
         if (c->chunk_item->type & BLOCK_FLAG_RAID0)
             factor = c->chunk_item->num_stripes;
         else if (c->chunk_item->type & BLOCK_FLAG_RAID10)
@@ -1921,48 +2253,49 @@
             factor = c->chunk_item->num_stripes - 2;
         else // SINGLE, DUPLICATE, RAID1
             factor = 1;
-        
+
         physsize = c->chunk_item->size / factor;
-        
+
         for (i = 0; i < c->chunk_item->num_stripes; i++) {
-            if (cis[i].offset >= opts->drange_start && cis[i].offset + physsize < opts->drange_end) {
+            if (cis[i].offset < opts->drange_end && cis[i].offset + physsize >= opts->drange_start &&
+                (!(opts->flags & BTRFS_BALANCE_OPTS_DEVID) || cis[i].dev_id == opts->devid)) {
                 b = TRUE;
                 break;
             }
         }
-        
+
         if (!b)
             return FALSE;
     }
-    
+
     if (opts->flags & BTRFS_BALANCE_OPTS_VRANGE) {
         if (c->offset + c->chunk_item->size <= opts->vrange_start || c->offset > opts->vrange_end)
             return FALSE;
     }
-    
+
     if (opts->flags & BTRFS_BALANCE_OPTS_STRIPES) {
         if (c->chunk_item->num_stripes < opts->stripes_start || c->chunk_item->num_stripes < opts->stripes_end)
             return FALSE;
     }
-    
+
     if (opts->flags & BTRFS_BALANCE_OPTS_USAGE) {
         UINT64 usage = c->used * 100 / c->chunk_item->size;
-        
+
         // usage == 0 should mean completely empty, not just that usage rounds to 0%
         if (c->used > 0 && usage == 0)
             usage = 1;
-        
+
         if (usage < opts->usage_start || usage > opts->usage_end)
             return FALSE;
     }
-    
+
     if (opts->flags & BTRFS_BALANCE_OPTS_CONVERT && opts->flags & BTRFS_BALANCE_OPTS_SOFT) {
         UINT64 type = get_chunk_dup_type(c);
-        
+
         if (type == opts->convert)
             return FALSE;
     }
-    
+
     return TRUE;
 }
 
@@ -1987,32 +2320,32 @@
         args->devid = opts->devid;
         args->flags |= BALANCE_ARGS_FLAGS_DEVID;
     }
-    
+
     if (opts->flags & BTRFS_BALANCE_OPTS_DRANGE) {
         args->drange_start = opts->drange_start;
         args->drange_end = opts->drange_end;
         args->flags |= BALANCE_ARGS_FLAGS_DRANGE;
     }
-    
+
     if (opts->flags & BTRFS_BALANCE_OPTS_VRANGE) {
         args->vrange_start = opts->vrange_start;
         args->vrange_end = opts->vrange_end;
         args->flags |= BALANCE_ARGS_FLAGS_VRANGE;
     }
-    
+
     if (opts->flags & BTRFS_BALANCE_OPTS_CONVERT) {
         args->convert = opts->convert;
         args->flags |= BALANCE_ARGS_FLAGS_CONVERT;
-        
+
         if (opts->flags & BTRFS_BALANCE_OPTS_SOFT)
             args->flags |= BALANCE_ARGS_FLAGS_SOFT;
     }
-    
+
     if (opts->flags & BTRFS_BALANCE_OPTS_LIMIT) {
         if (args->limit_start == 0) {
             args->flags |= BALANCE_ARGS_FLAGS_LIMIT_RANGE;
-            args->limit_start = opts->limit_start;
-            args->limit_end = opts->limit_end;
+            args->limit_start = (UINT32)opts->limit_start;
+            args->limit_end = (UINT32)opts->limit_end;
         } else {
             args->flags |= BALANCE_ARGS_FLAGS_LIMIT;
             args->limit = opts->limit_end;
@@ -2027,29 +2360,31 @@
 }
 
 static NTSTATUS add_balance_item(device_extension* Vcb) {
-    LIST_ENTRY rollback;
     KEY searchkey;
     traverse_ptr tp;
     NTSTATUS Status;
     BALANCE_ITEM* bi;
-    
-    InitializeListHead(&rollback);
-    
+
     searchkey.obj_id = BALANCE_ITEM_ID;
     searchkey.obj_type = TYPE_TEMP_ITEM;
     searchkey.offset = 0;
-    
+
     ExAcquireResourceExclusiveLite(&Vcb->tree_lock, TRUE);
-    
+
     Status = find_item(Vcb, Vcb->root_root, &tp, &searchkey, FALSE, NULL);
     if (!NT_SUCCESS(Status)) {
         ERR("find_item returned %08x\n", Status);
         goto end;
     }
-    
-    if (!keycmp(tp.item->key, searchkey))
-        delete_tree_item(Vcb, &tp, &rollback);
-    
+
+    if (!keycmp(tp.item->key, searchkey)) {
+        Status = delete_tree_item(Vcb, &tp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("delete_tree_item returned %08x\n", Status);
+            goto end;
+        }
+    }
+
     bi = ExAllocatePoolWithTag(PagedPool, sizeof(BALANCE_ITEM), ALLOC_TAG);
     if (!bi) {
         ERR("out of memory\n");
@@ -2056,146 +2391,148 @@
         Status = STATUS_INSUFFICIENT_RESOURCES;
         goto end;
     }
-    
+
     RtlZeroMemory(bi, sizeof(BALANCE_ITEM));
-    
+
     if (Vcb->balance.opts[BALANCE_OPTS_DATA].flags & BTRFS_BALANCE_OPTS_ENABLED) {
         bi->flags |= BALANCE_FLAGS_DATA;
         copy_balance_args(&Vcb->balance.opts[BALANCE_OPTS_DATA], &bi->data);
     }
-    
+
     if (Vcb->balance.opts[BALANCE_OPTS_METADATA].flags & BTRFS_BALANCE_OPTS_ENABLED) {
         bi->flags |= BALANCE_FLAGS_METADATA;
         copy_balance_args(&Vcb->balance.opts[BALANCE_OPTS_METADATA], &bi->metadata);
     }
-    
+
     if (Vcb->balance.opts[BALANCE_OPTS_SYSTEM].flags & BTRFS_BALANCE_OPTS_ENABLED) {
         bi->flags |= BALANCE_FLAGS_SYSTEM;
         copy_balance_args(&Vcb->balance.opts[BALANCE_OPTS_SYSTEM], &bi->system);
     }
-    
-    if (!insert_tree_item(Vcb, Vcb->root_root, BALANCE_ITEM_ID, TYPE_TEMP_ITEM, 0, bi, sizeof(BALANCE_ITEM), NULL, NULL, &rollback)) {
-        ERR("insert_tree_item failed\n");
-        Status = STATUS_INTERNAL_ERROR;
+
+    Status = insert_tree_item(Vcb, Vcb->root_root, BALANCE_ITEM_ID, TYPE_TEMP_ITEM, 0, bi, sizeof(BALANCE_ITEM), NULL, NULL);
+    if (!NT_SUCCESS(Status)) {
+        ERR("insert_tree_item returned %08x\n", Status);
+        ExFreePool(bi);
         goto end;
     }
-    
+
     Status = STATUS_SUCCESS;
-    
+
 end:
     if (NT_SUCCESS(Status)) {
-        do_write(Vcb, NULL, &rollback);
-        free_trees(Vcb);
-        
-        clear_rollback(Vcb, &rollback);
-    } else
-        do_rollback(Vcb, &rollback);
-    
+        Status = do_write(Vcb, NULL);
+        if (!NT_SUCCESS(Status))
+            ERR("do_write returned %08x\n", Status);
+    }
+
+    free_trees(Vcb);
+
     ExReleaseResourceLite(&Vcb->tree_lock);
-    
+
     return Status;
 }
 
 static NTSTATUS remove_balance_item(device_extension* Vcb) {
-    LIST_ENTRY rollback;
     KEY searchkey;
     traverse_ptr tp;
     NTSTATUS Status;
-    
-    InitializeListHead(&rollback);
-    
+
     searchkey.obj_id = BALANCE_ITEM_ID;
     searchkey.obj_type = TYPE_TEMP_ITEM;
     searchkey.offset = 0;
-    
+
     ExAcquireResourceExclusiveLite(&Vcb->tree_lock, TRUE);
-    
+
     Status = find_item(Vcb, Vcb->root_root, &tp, &searchkey, FALSE, NULL);
     if (!NT_SUCCESS(Status)) {
         ERR("find_item returned %08x\n", Status);
         goto end;
     }
-    
+
     if (!keycmp(tp.item->key, searchkey)) {
-        delete_tree_item(Vcb, &tp, &rollback);
-        
-        do_write(Vcb, NULL, &rollback);
+        Status = delete_tree_item(Vcb, &tp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("delete_tree_item returned %08x\n", Status);
+            goto end;
+        }
+
+        Status = do_write(Vcb, NULL);
+        if (!NT_SUCCESS(Status)) {
+            ERR("do_write returned %08x\n", Status);
+            goto end;
+        }
+
         free_trees(Vcb);
     }
 
     Status = STATUS_SUCCESS;
-    
+
 end:
-    if (NT_SUCCESS(Status))
-        clear_rollback(Vcb, &rollback);
-    else
-        do_rollback(Vcb, &rollback);
-    
     ExReleaseResourceLite(&Vcb->tree_lock);
-    
+
     return Status;
 }
 
 static void load_balance_args(btrfs_balance_opts* opts, BALANCE_ARGS* args) {
     opts->flags = BTRFS_BALANCE_OPTS_ENABLED;
-    
+
     if (args->flags & BALANCE_ARGS_FLAGS_PROFILES) {
         opts->flags |= BTRFS_BALANCE_OPTS_PROFILES;
         opts->profiles = args->profiles;
     }
-    
+
     if (args->flags & BALANCE_ARGS_FLAGS_USAGE) {
         opts->flags |= BTRFS_BALANCE_OPTS_USAGE;
-        
+
         opts->usage_start = 0;
-        opts->usage_end = args->usage;
+        opts->usage_end = (UINT8)args->usage;
     } else if (args->flags & BALANCE_ARGS_FLAGS_USAGE_RANGE) {
         opts->flags |= BTRFS_BALANCE_OPTS_USAGE;
-        
-        opts->usage_start = args->usage_start;
-        opts->usage_end = args->usage_end;
+
+        opts->usage_start = (UINT8)args->usage_start;
+        opts->usage_end = (UINT8)args->usage_end;
     }
-    
+
     if (args->flags & BALANCE_ARGS_FLAGS_DEVID) {
         opts->flags |= BTRFS_BALANCE_OPTS_DEVID;
         opts->devid = args->devid;
     }
-    
+
     if (args->flags & BALANCE_ARGS_FLAGS_DRANGE) {
         opts->flags |= BTRFS_BALANCE_OPTS_DRANGE;
         opts->drange_start = args->drange_start;
         opts->drange_end = args->drange_end;
     }
-    
+
     if (args->flags & BALANCE_ARGS_FLAGS_VRANGE) {
         opts->flags |= BTRFS_BALANCE_OPTS_VRANGE;
         opts->vrange_start = args->vrange_start;
         opts->vrange_end = args->vrange_end;
     }
-    
+
     if (args->flags & BALANCE_ARGS_FLAGS_LIMIT) {
         opts->flags |= BTRFS_BALANCE_OPTS_LIMIT;
-        
+
         opts->limit_start = 0;
         opts->limit_end = args->limit;
     } else if (args->flags & BALANCE_ARGS_FLAGS_LIMIT_RANGE) {
         opts->flags |= BTRFS_BALANCE_OPTS_LIMIT;
-        
+
         opts->limit_start = args->limit_start;
         opts->limit_end = args->limit_end;
     }
-    
+
     if (args->flags & BALANCE_ARGS_FLAGS_STRIPES_RANGE) {
         opts->flags |= BTRFS_BALANCE_OPTS_STRIPES;
-        
-        opts->stripes_start = args->stripes_start;
-        opts->stripes_end = args->stripes_end;
+
+        opts->stripes_start = (UINT16)args->stripes_start;
+        opts->stripes_end = (UINT16)args->stripes_end;
     }
-    
+
     if (args->flags & BALANCE_ARGS_FLAGS_CONVERT) {
         opts->flags |= BTRFS_BALANCE_OPTS_CONVERT;
         opts->convert = args->convert;
-        
+
         if (args->flags & BALANCE_ARGS_FLAGS_SOFT)
             opts->flags |= BTRFS_BALANCE_OPTS_SOFT;
     }
